Bug 1113106 - [RFE] add support for async queries
Summary: [RFE] add support for async queries
Keywords:
Status: CLOSED DEFERRED
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: libvirt
Version: 7.0
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Peter Krempa
QA Contact: Virtualization Bugs
URL:
Whiteboard:
Depends On:
Blocks: 1102147
TreeView+ depends on / blocked
 
Reported: 2014-06-25 12:51 UTC by Francesco Romani
Modified: 2016-02-11 09:22 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-02-11 09:22:49 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Francesco Romani 2014-06-25 12:51:43 UTC
Description of problem:
libvirt has many APIs to query the statistics of a domain, for example virDomainGetInfo, virDomainBlockInfo.

All these API are synchronous. Thus, a client application, like VDSM, needs to spawn a thread per Domain/VM in order to run all the queries.

This leads to waste of resources like the one found in https://bugzilla.redhat.com/show_bug.cgi?id=1102147#c54

We need a way to do async queries in order to reduce the number of active threads. This is to save resources, not for performance.

Comment 1 Francesco Romani 2014-06-25 13:07:57 UTC
Affected APIs as in vdsm 4.15 / oVirt 3.5.0:

virDomainBlockInfo
virDomainGetInfo
virDomainGetCPUStats
virDomainBlockStats
virDomainBlockStatsFlags
virDomainInterfaceStats
virDomainGetVcpusFlags
virDomainGetMetadata

and their python counterpart

Comment 2 Francesco Romani 2014-07-08 06:23:07 UTC
from the list on https://bugzilla.redhat.com/show_bug.cgi?id=1113106#c1

virDomainGetMetadata can be elided once https://bugzilla.redhat.com/show_bug.cgi?id=1114492 is fixed

Comment 6 Peter Krempa 2016-02-11 09:22:49 UTC
For now it looks like the normal bulk stats API is sufficient. If it proves necessary to provide the async one please reopen this BZ.


Note You need to log in before you can comment on or make changes to this bug.